Subject: Re: 2.29.0.rc0.windows.1: Duplicate commit id error message when fetching

From: Jeff King <[email-masked]>
Date: Fri, 9 Oct 2020 13:55:06 -0400

On Fri, Oct 09, 2020 at 01:46:07PM -0400, Derrick Stolee wrote:

> > Can you reproduce it if you do
> > 
> > git config core.commitGraph false
> > git config fetch.writeCommitGraph true
> > ?
> 
> I _can_ repro it in this case! I think there must be something
> very interesting going on where the commit-graph is parsed in
> _some_ places, but not in others. This is something that I can
> really start to dig into.

Here's a much more minimal reproduction:

  git init repo
  cd repo

  git commit --allow-empty -m one
  git rev-parse HEAD |
  git -c core.commitGraph=false \
      commit-graph write --split=no-merge --stdin-commits
  git rev-parse HEAD |
  git -c core.commitGraph=false \
      commit-graph write --split=no-merge --stdin-commits

  git commit --allow-empty -m two
  git rev-parse HEAD |
  git commit-graph write --split --stdin-commits

The final write will die() with the "unexpected duplicate" message.

-Peff